/*
 * WARNING: This file is auto-generated by an internal Red Hat script and,
 * in general, should not be modified by hand.
 * See: https://gitlab.com/redhat/rhel/src/kernel/hardware-removal-support
 */

/*
 * The following tables are used by Red Hat to define what hardware and drivers
 * are unsupported, or have limited support in RHEL major and minor releases.
 *
 * Generally, the process of disabling a driver or device in RHEL requires the
 * driver or device to be marked as 'deprecated' in all existing releases, and
 * then either 'unmaintained' or 'disabled' in a future release.
 *
 * In general, deprecated and unmaintained drivers continue to receive security
 * related fixes until they are disabled.
 */
 
#ifndef __RH_MESSAGES_H
#define __RH_MESSAGES_H

#include <linux/version.h>
#include <linux/pci.h>

#define DEV_DESC_LEN 256

#define RH_UNMAINT_HW "Warning: Unmaintained Hardware is detected: %s:%s\n"

#define RH_UNMAINT_DR "Warning: Unmaintained driver is detected: %s\n"

#define RH_DEPRECATED_HW "Warning: Deprecated Hardware is detected: %s:%s " \
			 "will not be maintained in a future major release " \
			 "and may be disabled\n"

#define RH_DEPRECATED_DR "Warning: Deprecated Driver is detected: %s will " \
			 "not be maintained in a future major release and " \
			 "may be disabled\n"

#define RH_DISABLED_HW "Warning: Disabled Hardware is detected: %s:%s is " \
		       "no longer enabled in this release.\n"

#define RH_TECH_PREVIEW "TECH PREVIEW: %s may not be fully supported.\n" \
			"Please review provided documentation for " \
			"limitations.\n"

#define RH_PARTNER_SUPPORTED "Warning: %s is a Partner supported GPL " \
			     "module and not supported directly by Red Hat.\n"

static const char *rh_deprecated_drivers[] = {
	"aacraid",
	"af_key",
	"firewire-core",
	"team",
	0     /* Terminating entry */
};

static const char *rh_deprecated_init_fns[] = {
	"team_module_init",
	"fw_core_init",
	"ipsec_pfkey_init",
	"aac_init",
	0     /* Terminating entry */
};

static const char *rh_unmaintained_drivers[] = {
	"arp_tables",
	"bnx2",
	"dl2k",
	"e1000",
	"ebtables",
	"hdlc_fr",
	"hpsa",
	"ip6_tables",
	"ip_set",
	"ip_tables",
	"mptbase",
	"mptsas",
	"mptscsih",
	"mptspi",
	"myri10ge",
	"netxen_nic",
	"nft_compat",
	"nicpf",
	"nicvf",
	"nvmet-fc",
	"nvmet-tcp",
	"qla3xxx",
	0     /* Terminating entry */
};

static const char *rh_unmaintained_init_fns[] = {
	"bnx2_pci_driver_init",
	"e1000_init_module",
	"rio_driver_init",
	"hpsa_init",
	"fusion_init",
	"mptsas_init",
	"fusion_init",
	"mptspi_init",
	"myri10ge_init_module",
	"netxen_init_module",
	"ql3xxx_driver_init",
	"hdlc_fr_init",
	"nvmet_fc_init_module",
	"nvmet_tcp_init",
	"ebtables_init",
	"arp_tables_init",
	"ip_tables_init",
	"ip6_tables_init",
	"ip_set_init",
	"nft_compat_module_init",
	"nicvf_init_module",
	"nic_init_module",
	0     /* Terminating entry */
};

static const struct pci_device_id rh_deprecated_pci_devices[] = {
	{0}     /* Terminating entry */
};

static const struct pci_device_id rh_disabled_pci_devices[] = {
	{0}     /* Terminating entry */
};

static const struct pci_device_id rh_unmaintained_pci_devices[] = {
	{0}     /* Terminating entry */
};

#endif /* __RH_MESSAGES_H */
